;	RCS Header $Id: FXM0808U.ASM,v 1.2 2000/02/22 22:15:28 krt Exp $

;	$Revision: 1.2 $

	include <P17C44.INC>		; General 17CXXX definitions

	include <CMATH17.INC>		; Math library definitions

;**********************************************************************************************
;**********************************************************************************************

;       8x8 Bit Unsigned Fixed Point Multiply 08 x 08 -> 16

;       Input:  8 bit unsigned fixed point multiplicand in AARGB0
;               8 bit unsigned fixed point multiplier in BARGB0

;       Use:    CALL    FXM0808U

;       Output: 16 bit unsigned fixed point product in AARGB0, AARGB1

;       Result: AARG  <--  AARG * BARG

;	Testing on [0x00,0xFF] from 100000 trials:

;		min	max	mean
;	Timing:	6	6	6	clks

;       PM: 5              DM: 3

PROG		CODE

FXM0808U
		GLOBAL	FXM0808U

		MOVFP	BARGB0,WREG
		MULWF	AARGB0
		MOVPF	PRODH,AARGB0
		MOVPF	PRODL,AARGB1
		RETLW	0x00

		END
