@echo off
if exist CMATH17.LIB del CMATH17.LIB

echo Create CMATH17 math libary

echo Building modules...
MPASM /o /q /p17cxx CMATH17.ASM
MPASM /o /q /p17cxx FLO0832.ASM
MPASM /o /q /p17cxx FLO1632.ASM
MPASM /o /q /p17cxx FLO3232.ASM
REM MPASM /o /q /p17cxx FLOOR32.ASM
MPASM /o /q /p17cxx FPD32.ASM
MPASM /o /q /p17cxx FPM32.ASM
MPASM /o /q /p17cxx FPAS32.ASM
MPASM /o /q /p17cxx FXD0808S.ASM
MPASM /o /q /p17cxx FXD0808U.ASM
MPASM /o /q /p17cxx FXD1608S.ASM
MPASM /o /q /p17cxx FXD1608U.ASM
MPASM /o /q /p17cxx FXD1616S.ASM
MPASM /o /q /p17cxx FXD1616U.ASM
MPASM /o /q /p17cxx FXD2424U.ASM
MPASM /o /q /p17cxx FXD2416U.ASM
MPASM /o /q /p17cxx FXD2408U.ASM
MPASM /o /q /p17cxx FXD3216S.ASM
MPASM /o /q /p17cxx FXD3216U.ASM
MPASM /o /q /p17cxx FXD3208U.ASM
MPASM /o /q /p17cxx FXD3224U.ASM
MPASM /o /q /p17cxx FXD3232S.ASM
MPASM /o /q /p17cxx FXD3232U.ASM
MPASM /o /q /p17cxx FXM0808S.ASM
MPASM /o /q /p17cxx FXM0808U.ASM
MPASM /o /q /p17cxx FXM1608S.ASM
MPASM /o /q /p17cxx FXM1608U.ASM
MPASM /o /q /p17cxx FXM1616S.ASM
MPASM /o /q /p17cxx FXM1616U.ASM
MPASM /o /q /p17cxx FXM3216S.ASM
MPASM /o /q /p17cxx FXM3216U.ASM
MPASM /o /q /p17cxx FXM3224U.ASM
MPASM /o /q /p17cxx FXM3232S.ASM
MPASM /o /q /p17cxx FXM3232U.ASM
REM MPASM /o /q /p17cxx HANDLERS.ASM
MPASM /o /q /p17cxx INT3208.ASM
MPASM /o /q /p17cxx INT3216.ASM
MPASM /o /q /p17cxx INT3232.ASM
MPASM /o /q /p17cxx INT2424.ASM
MPASM /o /q /p17cxx INT2416.ASM
REM MPASM /o /q /p17cxx NORM32.ASM
MPASM /o /q /p17cxx RAND32.ASM
MPASM /o /q /p17cxx TAEQB32.ASM
MPASM /o /q /p17cxx TAGEB32.ASM
MPASM /o /q /p17cxx TAGTB32.ASM
MPASM /o /q /p17cxx TALEB32.ASM
MPASM /o /q /p17cxx TALTB32.ASM
MPASM /o /q /p17cxx TANEB32.ASM
MPASM /o /q /p17cxx UTIL32.ASM
echo Adding modules to library...
mplib /q /c cmath17.lib
mplib /q /r cmath17.lib CMATH17.O
mplib /q /r cmath17.lib FLO0832.O
mplib /q /r cmath17.lib FLO1632.O
mplib /q /r cmath17.lib FLO3232.O
REM mplib /q /r cmath17.lib FLOOR32.O
mplib /q /r cmath17.lib FPD32.O
mplib /q /r cmath17.lib FPM32.O
mplib /q /r cmath17.lib FPAS32.O
mplib /q /r cmath17.lib FXD0808S.O
mplib /q /r cmath17.lib FXD0808U.O
mplib /q /r cmath17.lib FXD1608S.O
mplib /q /r cmath17.lib FXD1608U.O
mplib /q /r cmath17.lib FXD1616S.O
mplib /q /r cmath17.lib FXD1616U.O
mplib /q /r cmath17.lib FXD2424U.O
mplib /q /r cmath17.lib FXD2416U.O
mplib /q /r cmath17.lib FXD2408U.O
mplib /q /r cmath17.lib FXD3216S.O
mplib /q /r cmath17.lib FXD3208U.O
mplib /q /r cmath17.lib FXD3216U.O
mplib /q /r cmath17.lib FXD3224U.O
mplib /q /r cmath17.lib FXD3232S.O
mplib /q /r cmath17.lib FXD3232U.O
mplib /q /r cmath17.lib FXM0808S.O
mplib /q /r cmath17.lib FXM0808U.O
mplib /q /r cmath17.lib FXM1608S.O
mplib /q /r cmath17.lib FXM1608U.O
mplib /q /r cmath17.lib FXM1616S.O
mplib /q /r cmath17.lib FXM1616U.O
mplib /q /r cmath17.lib FXM3216S.O
mplib /q /r cmath17.lib FXM3216U.O
mplib /q /r cmath17.lib FXM3224U.O
mplib /q /r cmath17.lib FXM3232S.O
mplib /q /r cmath17.lib FXM3232U.O
REM mplib /q /r cmath17.lib HANDLERS.O
mplib /q /r cmath17.lib INT3208.O
mplib /q /r cmath17.lib INT3216.O
mplib /q /r cmath17.lib INT3232.O
mplib /q /r cmath17.lib INT2424.O
mplib /q /r cmath17.lib INT2416.O
REM mplib /q /r cmath17.lib NORM32.O
mplib /q /r cmath17.lib RAND32.O
mplib /q /r cmath17.lib TAEQB32.O
mplib /q /r cmath17.lib TAGEB32.O
mplib /q /r cmath17.lib TAGTB32.O
mplib /q /r cmath17.lib TALEB32.O
mplib /q /r cmath17.lib TALTB32.O
mplib /q /r cmath17.lib TANEB32.O
mplib /q /r cmath17.lib UTIL32.O